#1 - 09/16/2014 03:36 PM - Miroslav Fidler
/* WITH query (from PostgreSQL manual)
http://www.postgresql.org/docs/8.4/static/queries-with.html
Should work also in other SQL */
class SqlWith {
String prefix;
String table;
String columns;
public:
class SqlWithAs {
String text;
public:
SqlWithAs(const String& t) : text(t) {}
SqlWith With(Sqlld table) const { return SqlWith(table, text + ", "); }
SqlStatement operator()(const SqlSelect& s) { return SglStatement("with " + text + " " + SqlStatement(s).GetText()); }
I8
SqlWith(Sqlld table, String prefix = ") : table(table.ToString()), prefix(prefix) {}
void Column(Sqlld col) { if(!IsNull(columns)) columns << ", "; columns << "\t" << col.ToString() << "\t"; }
#define E__Sqlld(l) const Sqlld& p##l
#define E__Column(l) Column(p##1)
#define E__Braces(l) SqlWith& operator()(__List##I(E__Sqlld)) { __List##|(E__Column); return *this;}
__Expand(E__Braces)
#undef E__Braces
#undef E__Sqlld
#undef E__Sqlld

SqlWithAs As(const SqlSelect& s) {
String c;
if (!IsNull(columns)) ¢ << "(" << columns << ")";
return SqIWithAs("\t" + table + "\t" + ¢ + " as (" + SqlStatement(s).GetText() + ")");

inline SqlWith With(Sqlld table) { return SqlWith(table); }
inline SqlWith WithRecursive(Sqlld table) { return SglWith(table, "recursive "); }
#2 - 09/17/2014 09:29 AM - Miroslav Fidler
SQL example (that has to be supported):

with RECURSIVE tn as (

select id, name, parent_id from treenode where parent_id = -1

union ALL

select treenode.id, treenode.name, treenode.parent_id from treenode, tn where treenode.PARENT_id = tn.ID

)

tng as (select parent_id, (select name from treenode where id = tn.parent_id), count(*) from tn group by parent_id)
select * from tng;

#3 - 09/20/2014 09:35 AM - Miroslav Fidler
- Status changed from New to Approved
